﻿(function() {

    configRequire();

    function configRequire() {
        requirejs.config({
            paths: { 'breeze': 'Scripts/breeze.debug' }
        });
    }

    require(['breeze'], function (breeze) {

        // Combines viewmodel and boot - for test purposes only
        var core = breeze.core,
            entityModel = breeze.entityModel;

        core.config.setProperties({
            trackingImplementation: entityModel.entityTracking_ko,
            remoteAccessImplementation: entityModel.remoteAccess_webApi
        });

        var serviceName = 'api/breezetest';
        var manager = new entityModel.EntityManager(serviceName);

        var viewModel = {
            items: ko.observableArray()
        };

        var query = new entityModel.EntityQuery().from("items");

        log("Querying ...");
        manager.executeQuery(query)
            .then(querySucceeded)
            .fail(queryFailed);

        function querySucceeded(data) {
            log("Query succeeded");
            log(data.results.length + " items from query");
            log(manager.getEntities().length + " entities in cache");
            viewModel.items(data.results);
        }

        function queryFailed(error) {
            log("Query failed: " + error.message);
        }

        function log(msg) {
            $('#logmessages').append(msg + "<br/>");
        }


        ko.applyBindings(viewModel, $("#content").get(0));

    });

})();
